;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 10,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _hl=R5
	.DEF _hh=R4
	.DEF _kk=R7
	.DEF _key=R6
	.DEF _i=R9
	.DEF _id=R8
	.DEF _a=R11
	.DEF _tm=R10
	.DEF _temp=R13
	.DEF _work=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0x3F,0x6,0x5B,0x4F,0x66,0x6D,0x7D,0x27
	.DB  0x7F,0x6F
_0x4:
	.DB  0xA
_0x8F:
	.DB  0xB3,0xB4,0x0,0xF3,0x0,0x0,0x0,0x0
	.DB  0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  _ar
	.DW  _0x3*2

	.DW  0x01
	.DW  _us
	.DW  _0x4*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x8F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Project :   
;Date    : 5.01.2010
;Author  :   .
;Chip type           : ATmega8
;Clock frequency     : 10,000000 MHz
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 256
;*****************************************************/
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;const char hl=180;
;const char hh=179;
;const char kk=243;
;unsigned char ar[]={63,6,91,79,102,109,125,39,127,111};

	.DSEG
;unsigned char key=0;
;unsigned char i=0;
;unsigned char id=0;
;unsigned char a =0;
;unsigned char tm=0;
;unsigned char temp=0;
;unsigned char work=0;
;unsigned char du=0;
;unsigned char b=0;
;unsigned char us=10;
;unsigned char un=0;
;unsigned char ut=0;
;unsigned char tt=0;
;unsigned char u=0;
;unsigned char t=0;
;unsigned char h=0;
;unsigned char rr=0;
;unsigned char zv=0;
;unsigned char e =0;
;bit p=0;
;unsigned int cap =0;
;unsigned int v =0;
;// Timer 0 overflow interrupt service routine
;//       0
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 002A {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 002B if(++p==0){PORTC.3=0;}
	LDI  R30,LOW(1)
	EOR  R2,R30
	BST  R2,0
	LDI  R30,LOW(0)
	BLD  R30,0
	CPI  R30,0
	BRNE _0x5
	CBI  0x15,3
; 0000 002C else {PORTC.3=1;}
	RJMP _0x8
_0x5:
	SBI  0x15,3
_0x8:
; 0000 002D if (TCCR0==4){TCNT0=kk;}
	IN   R30,0x33
	CPI  R30,LOW(0x4)
	BRNE _0xB
	OUT  0x32,R7
; 0000 002E }
_0xB:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;// Timer 1 overflow interrupt service routine
;//       1
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0032 {
_timer1_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0033 a++;
	INC  R11
; 0000 0034 if (a==180){a=0; tm++;}
	LDI  R30,LOW(180)
	CP   R30,R11
	BRNE _0xC
	CLR  R11
	INC  R10
; 0000 0035 PORTB.0=a&1;
_0xC:
	SBRC R11,0
	RJMP _0xD
	CBI  0x18,0
	RJMP _0xE
_0xD:
	SBI  0x18,0
_0xE:
; 0000 0036 TCNT1L=hl;
	OUT  0x2C,R5
; 0000 0037 TCNT1H=hh;
	OUT  0x2D,R4
; 0000 0038 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;// Subroutine ADC
;//      
;void read_adc(void)
; 0000 003C {
_read_adc:
; 0000 003D delay_us(10);
	__DELAY_USB 33
; 0000 003E ADCSRA|=0x40;
	SBI  0x6,6
; 0000 003F while ((ADCSRA & 0x10)==0);
_0xF:
	SBIS 0x6,4
	RJMP _0xF
; 0000 0040 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0041 }
	RET
;//Subroutine of division for unsigned byte register
;//   8  
;void div(void)
; 0000 0045 {
_div:
; 0000 0046 temp=du;
	LDS  R13,_du
; 0000 0047 h= temp/100;
	MOV  R26,R13
	LDI  R27,0
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	STS  _h,R30
; 0000 0048 temp = temp%100;
	MOV  R26,R13
	CLR  R27
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21
	MOV  R13,R30
; 0000 0049 t=temp/10;
	MOV  R26,R13
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	STS  _t,R30
; 0000 004A u= temp%10;
	MOV  R26,R13
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	STS  _u,R30
; 0000 004B }
	RET
;//Subroutine of output of data for low marks on indicator
;//      
;void strob(void)
; 0000 004F {
_strob:
; 0000 0050 if(id!=0)
	TST  R8
	BREQ _0x12
; 0000 0051  {
; 0000 0052  if (id==1){PORTD=16;}
	LDI  R30,LOW(1)
	CP   R30,R8
	BRNE _0x13
	LDI  R30,LOW(16)
	OUT  0x12,R30
; 0000 0053  if (id==2){PORTD=80;}
_0x13:
	LDI  R30,LOW(2)
	CP   R30,R8
	BRNE _0x14
	LDI  R30,LOW(80)
	OUT  0x12,R30
; 0000 0054  if (id==3){PORTD=32;}
_0x14:
	LDI  R30,LOW(3)
	CP   R30,R8
	BRNE _0x15
	LDI  R30,LOW(32)
	OUT  0x12,R30
; 0000 0055  PORTB.1=0;
_0x15:
	CBI  0x18,1
; 0000 0056  delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0057  PORTB.1=1;
	SBI  0x18,1
; 0000 0058  }
; 0000 0059 PORTD=ar[h];
_0x12:
	LDS  R30,_h
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
	OUT  0x12,R30
; 0000 005A if(id!=2)
	LDI  R30,LOW(2)
	CP   R30,R8
	BREQ _0x1A
; 0000 005B  {PORTD.7=1;}
	SBI  0x12,7
; 0000 005C PORTC.0=0;
_0x1A:
	CBI  0x15,0
; 0000 005D delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 005E PORTC.0=1;
	SBI  0x15,0
; 0000 005F delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0060 PORTD=ar[t];
	LDS  R30,_t
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
	OUT  0x12,R30
; 0000 0061 if(id==2){PORTD.7=1;}
	LDI  R30,LOW(2)
	CP   R30,R8
	BRNE _0x21
	SBI  0x12,7
; 0000 0062 PORTC.1=0;
_0x21:
	CBI  0x15,1
; 0000 0063 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0064 PORTC.1=1;
	SBI  0x15,1
; 0000 0065 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0066 PORTD=ar[u];
	LDS  R30,_u
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
	OUT  0x12,R30
; 0000 0067 PORTC.2=0;
	CBI  0x15,2
; 0000 0068 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0069 PORTC.2=1;
	SBI  0x15,2
; 0000 006A delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 006B }
	RET
;//Main programm
;// 
;void main(void)
; 0000 006F {
_main:
; 0000 0070 unsigned char z =120;  //    
; 0000 0071 PORTB=0x37;
;	z -> R17
	LDI  R17,120
	LDI  R30,LOW(55)
	OUT  0x18,R30
; 0000 0072 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
; 0000 0073 PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 0074 DDRC=0x0F;
	OUT  0x14,R30
; 0000 0075 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0076 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 0077 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0078 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0079 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 007A TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 007B TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 007C TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 007D ICR1H=0x00;
	OUT  0x27,R30
; 0000 007E ICR1L=0x00;
	OUT  0x26,R30
; 0000 007F OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0080 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0081 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0082 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0083 ASSR=0x00;
	OUT  0x22,R30
; 0000 0084 TCCR2=0x6A;
	LDI  R30,LOW(106)
	OUT  0x25,R30
; 0000 0085 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0086 OCR2=0x00;
	OUT  0x23,R30
; 0000 0087 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0088 TIMSK=0x05;
	LDI  R30,LOW(5)
	OUT  0x39,R30
; 0000 0089 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 008A SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 008B ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
; 0000 008C ADMUX=101;
	LDI  R30,LOW(101)
	OUT  0x7,R30
; 0000 008D // Global enable interrupts
; 0000 008E #asm("sei")
	sei
; 0000 008F while (1)
_0x2C:
; 0000 0090       {
; 0000 0091       id=0;
	CLR  R8
; 0000 0092       read_adc();
	RCALL _read_adc
; 0000 0093       ut=ADCH;
	IN   R30,0x5
	STS  _ut,R30
; 0000 0094       du=us;
	LDS  R30,_us
	STS  _du,R30
; 0000 0095       zv++;
	LDS  R30,_zv
	SUBI R30,-LOW(1)
	STS  _zv,R30
; 0000 0096       if (ut<10)
	LDS  R26,_ut
	CPI  R26,LOW(0xA)
	BRSH _0x2F
; 0000 0097        {
; 0000 0098         switch (zv)
	LDI  R31,0
; 0000 0099         {
; 0000 009A          case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x33
; 0000 009B          TCCR0=3;       // 3000 
	LDI  R30,LOW(3)
	RJMP _0x8B
; 0000 009C          break;
; 0000 009D          case 3:
_0x33:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x34
; 0000 009E          TCCR0=3;
	LDI  R30,LOW(3)
	RJMP _0x8B
; 0000 009F          break;
; 0000 00A0          case 5:
_0x34:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x36
; 0000 00A1          TCCR0=3;
	LDI  R30,LOW(3)
	RJMP _0x8B
; 0000 00A2          break;
; 0000 00A3          default:TCCR0=0;   // 
_0x36:
	LDI  R30,LOW(0)
_0x8B:
	OUT  0x33,R30
; 0000 00A4         }
; 0000 00A5        if (zv >= 20){zv=TCCR0=0;}   //   
	LDS  R26,_zv
	CPI  R26,LOW(0x14)
	BRLO _0x37
	LDI  R30,LOW(0)
	OUT  0x33,R30
	STS  _zv,R30
; 0000 00A6        i=TCCR1B=0;
_0x37:
	LDI  R30,LOW(0)
	OUT  0x2E,R30
	MOV  R9,R30
; 0000 00A7        PORTB.0=1;
	SBI  0x18,0
; 0000 00A8        z=35;
	LDI  R17,LOW(35)
; 0000 00A9         goto iz;
	RJMP _0x3A
; 0000 00AA        }
; 0000 00AB       ADMUX=100;
_0x2F:
	LDI  R30,LOW(100)
	OUT  0x7,R30
; 0000 00AC       read_adc();
	RCALL _read_adc
; 0000 00AD       key=ADCH;
	IN   R6,5
; 0000 00AE       ADMUX=101;
	LDI  R30,LOW(101)
	OUT  0x7,R30
; 0000 00AF       key= key & 224;   //   
	LDI  R30,LOW(224)
	AND  R6,R30
; 0000 00B0       if (key == 32)    //   SB1
	LDI  R30,LOW(32)
	CP   R30,R6
	BRNE _0x3B
; 0000 00B1        {
; 0000 00B2         id=1;
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 00B3         e++;
	LDS  R30,_e
	SUBI R30,-LOW(1)
	STS  _e,R30
; 0000 00B4         switch(e)
	LDI  R31,0
; 0000 00B5         {
; 0000 00B6         case 5:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x3E
; 0000 00B7         e=4;
	LDI  R30,LOW(4)
	STS  _e,R30
; 0000 00B8         goto ip;
	RJMP _0x40
; 0000 00B9         break;
; 0000 00BA         }
_0x3E:
; 0000 00BB         goto ss;
	RJMP _0x41
; 0000 00BC         ip:
_0x40:
; 0000 00BD         id=3;
	LDI  R30,LOW(3)
	MOV  R8,R30
; 0000 00BE         if (b < 10)
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BRSH _0x42
; 0000 00BF         {
; 0000 00C0         if (i!= 255){i = i+5; b++;}
	LDI  R30,LOW(255)
	CP   R30,R9
	BREQ _0x43
	MOV  R30,R9
	LDI  R31,0
	ADIW R30,5
	MOV  R9,R30
	LDS  R30,_b
	SUBI R30,-LOW(1)
	STS  _b,R30
; 0000 00C1         }
_0x43:
; 0000 00C2         else
	RJMP _0x44
_0x42:
; 0000 00C3         {
; 0000 00C4         if (i < 241) {i=i+15;}
	LDI  R30,LOW(241)
	CP   R9,R30
	BRSH _0x45
	MOV  R30,R9
	LDI  R31,0
	ADIW R30,15
	MOV  R9,R30
; 0000 00C5         else {goto ex;}
	RJMP _0x46
_0x45:
	RJMP _0x47
_0x46:
; 0000 00C6         }
_0x44:
; 0000 00C7         goto ss;
	RJMP _0x41
; 0000 00C8        }
; 0000 00C9       if (key == 64)    //   SB2
_0x3B:
	LDI  R30,LOW(64)
	CP   R30,R6
	BRNE _0x48
; 0000 00CA        {
; 0000 00CB         id=1;
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 00CC         e++;
	LDS  R30,_e
	SUBI R30,-LOW(1)
	STS  _e,R30
; 0000 00CD         switch(e)
	LDI  R31,0
; 0000 00CE         {
; 0000 00CF         case 5:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x4B
; 0000 00D0         e=4;
	LDI  R30,LOW(4)
	STS  _e,R30
; 0000 00D1         goto im;
	RJMP _0x4D
; 0000 00D2         break;
; 0000 00D3         }
_0x4B:
; 0000 00D4         goto ss;
	RJMP _0x41
; 0000 00D5         im:
_0x4D:
; 0000 00D6         id=3;
	LDI  R30,LOW(3)
	MOV  R8,R30
; 0000 00D7         if (b < 10)
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BRSH _0x4E
; 0000 00D8         {
; 0000 00D9         if (i >= 5){i=i-5; b++;}
	LDI  R30,LOW(5)
	CP   R9,R30
	BRLO _0x4F
	MOV  R26,R9
	LDI  R27,0
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __SWAPW12
	SUB  R30,R26
	MOV  R9,R30
	LDS  R30,_b
	SUBI R30,-LOW(1)
	STS  _b,R30
; 0000 00DA         }
_0x4F:
; 0000 00DB         else
	RJMP _0x50
_0x4E:
; 0000 00DC         {
; 0000 00DD         if (i >= 15) {i=i-15;}
	LDI  R30,LOW(15)
	CP   R9,R30
	BRLO _0x51
	MOV  R26,R9
	LDI  R27,0
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RCALL __SWAPW12
	SUB  R30,R26
	MOV  R9,R30
; 0000 00DE         else {goto ex;}
	RJMP _0x52
_0x51:
	RJMP _0x47
_0x52:
; 0000 00DF         }
_0x50:
; 0000 00E0         goto ss;
	RJMP _0x41
; 0000 00E1        }
; 0000 00E2       if (key == 96)     //   SB3
_0x48:
	LDI  R30,LOW(96)
	CP   R30,R6
	BRNE _0x53
; 0000 00E3        {
; 0000 00E4         if (b < 10)
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BRSH _0x54
; 0000 00E5         {
; 0000 00E6         if (us < 255){b++; us++;}
	LDS  R26,_us
	CPI  R26,LOW(0xFF)
	BRSH _0x55
	LDS  R30,_b
	SUBI R30,-LOW(1)
	STS  _b,R30
	LDS  R30,_us
	SUBI R30,-LOW(1)
	STS  _us,R30
; 0000 00E7         }
_0x55:
; 0000 00E8         else
	RJMP _0x56
_0x54:
; 0000 00E9         {
; 0000 00EA         if (us < 246) {us=us+10;}
	LDS  R26,_us
	CPI  R26,LOW(0xF6)
	BRSH _0x57
	LDS  R30,_us
	LDI  R31,0
	ADIW R30,10
	STS  _us,R30
; 0000 00EB         else {goto ex;}
	RJMP _0x58
_0x57:
	RJMP _0x47
_0x58:
; 0000 00EC         }
_0x56:
; 0000 00ED         goto ss;
	RJMP _0x41
; 0000 00EE        }
; 0000 00EF       if (key == 128)   //   SB4
_0x53:
	LDI  R30,LOW(128)
	CP   R30,R6
	BRNE _0x59
; 0000 00F0        {
; 0000 00F1         if (b < 10)
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BRSH _0x5A
; 0000 00F2         {
; 0000 00F3         if (us >= 11){b++; us--;}
	LDS  R26,_us
	CPI  R26,LOW(0xB)
	BRLO _0x5B
	LDS  R30,_b
	SUBI R30,-LOW(1)
	STS  _b,R30
	LDS  R30,_us
	SUBI R30,LOW(1)
	STS  _us,R30
; 0000 00F4         }
_0x5B:
; 0000 00F5         else
	RJMP _0x5C
_0x5A:
; 0000 00F6         {
; 0000 00F7         if (us >= 20) {us=us-10;}
	LDS  R26,_us
	CPI  R26,LOW(0x14)
	BRLO _0x5D
	LDS  R30,_us
	LDI  R31,0
	SBIW R30,10
	STS  _us,R30
; 0000 00F8         else {goto ex;}
	RJMP _0x5E
_0x5D:
	RJMP _0x47
_0x5E:
; 0000 00F9         }
_0x5C:
; 0000 00FA         goto ss;
	RJMP _0x41
; 0000 00FB        }
; 0000 00FC       if (key == 160)    //   SB5
_0x59:
	LDI  R30,LOW(160)
	CP   R30,R6
	BRNE _0x5F
; 0000 00FD        {
; 0000 00FE        if (i!=0){goto ss;}    //
	TST  R9
	BRNE _0x41
; 0000 00FF        id=2;
	LDI  R30,LOW(2)
	MOV  R8,R30
; 0000 0100        OCR2 = 100;            //
	LDI  R30,LOW(100)
	OUT  0x23,R30
; 0000 0101        delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0102        read_adc();
	RCALL _read_adc
; 0000 0103        un= ADCH;              //
	IN   R30,0x5
	STS  _un,R30
; 0000 0104        if (ut >= un)
	LDS  R26,_ut
	CP   R26,R30
	BRLO _0x61
; 0000 0105         {
; 0000 0106         rr=ut-un;             //
	CLR  R27
	LDI  R31,0
	RCALL __SWAPW12
	SUB  R30,R26
	STS  _rr,R30
; 0000 0107         }
; 0000 0108        goto ss;
_0x61:
	RJMP _0x41
; 0000 0109        }
; 0000 010A       if (key == 224) {du=ut;}   //   SB6
_0x5F:
	LDI  R30,LOW(224)
	CP   R30,R6
	BRNE _0x62
	LDS  R30,_ut
	STS  _du,R30
; 0000 010B       ex:
_0x62:
_0x47:
; 0000 010C       b=e=0;
	LDI  R30,LOW(0)
	STS  _e,R30
	STS  _b,R30
; 0000 010D       ss:
_0x41:
; 0000 010E       key=0;
	CLR  R6
; 0000 010F       if (ut < us){i=0;}   //     
	LDS  R30,_us
	LDS  R26,_ut
	CP   R26,R30
	BRSH _0x63
	CLR  R9
; 0000 0110       if (i!=0) {cap=i*tm;TCCR1B=5;TCCR0=0;}
_0x63:
	TST  R9
	BREQ _0x64
	MOV  R26,R9
	CLR  R27
	MOV  R30,R10
	LDI  R31,0
	RCALL __MULW12
	STS  _cap,R30
	STS  _cap+1,R31
	LDI  R30,LOW(5)
	OUT  0x2E,R30
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0111       else {
	RJMP _0x65
_0x64:
; 0000 0112             TCCR1B=0; PORTB.0 = 1;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
	SBI  0x18,0
; 0000 0113             switch (zv)
	LDS  R30,_zv
	LDI  R31,0
; 0000 0114              {
; 0000 0115              case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x6B
; 0000 0116              TCCR0=4;     // 600 
	LDI  R30,LOW(4)
	RJMP _0x8C
; 0000 0117              break;
; 0000 0118              case 3:
_0x6B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x6D
; 0000 0119              TCCR0=4;
	LDI  R30,LOW(4)
	RJMP _0x8C
; 0000 011A              break;
; 0000 011B              default:TCCR0=0;
_0x6D:
	LDI  R30,LOW(0)
_0x8C:
	OUT  0x33,R30
; 0000 011C              }
; 0000 011D              if (zv >= 20){zv=TCCR0=0;}  //   
	LDS  R26,_zv
	CPI  R26,LOW(0x14)
	BRLO _0x6E
	LDI  R30,LOW(0)
	OUT  0x33,R30
	STS  _zv,R30
; 0000 011E              z=35; goto iz;
_0x6E:
	LDI  R17,LOW(35)
	RJMP _0x3A
; 0000 011F            }
_0x65:
; 0000 0120       z=120;    //    
	LDI  R17,LOW(120)
; 0000 0121       iz:       //
_0x3A:
; 0000 0122       OCR2=i;
	OUT  0x23,R9
; 0000 0123       div();
	RCALL _div
; 0000 0124       if (h==0){PORTD=0;}
	LDS  R30,_h
	CPI  R30,0
	BRNE _0x6F
	LDI  R30,LOW(0)
	RJMP _0x8D
; 0000 0125       else {PORTD=ar[h];}
_0x6F:
	LDS  R30,_h
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
_0x8D:
	OUT  0x12,R30
; 0000 0126       PORTB.5=0;
	CBI  0x18,5
; 0000 0127       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0128       PORTB.5=1;
	SBI  0x18,5
; 0000 0129       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 012A       PORTD=ar[t];
	LDS  R30,_t
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
	OUT  0x12,R30
; 0000 012B       PORTD.7=1;
	SBI  0x12,7
; 0000 012C       PORTB.4=0;
	CBI  0x18,4
; 0000 012D       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 012E       PORTB.4=1;
	SBI  0x18,4
; 0000 012F       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0130       PORTD=ar[u];
	LDS  R30,_u
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
	OUT  0x12,R30
; 0000 0131       PORTB.2=0;
	CBI  0x18,2
; 0000 0132       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0133       PORTB.2=1;
	SBI  0x18,2
; 0000 0134       delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0135       if (id==0)
	TST  R8
	BREQ PC+2
	RJMP _0x7F
; 0000 0136         {
; 0000 0137          v= cap;
	LDS  R30,_cap
	LDS  R31,_cap+1
	STS  _v,R30
	STS  _v+1,R31
; 0000 0138          tt= v/10000;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RCALL __DIVW21U
	STS  _tt,R30
; 0000 0139          v=v%10000;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RCALL __MODW21U
	STS  _v,R30
	STS  _v+1,R31
; 0000 013A          h=v/1000;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	STS  _h,R30
; 0000 013B          v=v%1000;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	STS  _v,R30
	STS  _v+1,R31
; 0000 013C          t=v/100;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	STS  _t,R30
; 0000 013D          v=v%100;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	STS  _v,R30
	STS  _v+1,R31
; 0000 013E          u=v/10;
	LDS  R26,_v
	LDS  R27,_v+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	STS  _u,R30
; 0000 013F          if (tt==0){PORTD=0;}
	LDS  R30,_tt
	CPI  R30,0
	BRNE _0x80
	LDI  R30,LOW(0)
	RJMP _0x8E
; 0000 0140          else {PORTD=ar[tt];}
_0x80:
	LDS  R30,_tt
	LDI  R31,0
	SUBI R30,LOW(-_ar)
	SBCI R31,HIGH(-_ar)
	LD   R30,Z
_0x8E:
	OUT  0x12,R30
; 0000 0141          PORTB.1=0;
	CBI  0x18,1
; 0000 0142          delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0143          PORTB.1=1;
	SBI  0x18,1
; 0000 0144          delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0145         }
; 0000 0146       else
	RJMP _0x86
_0x7F:
; 0000 0147         {
; 0000 0148          if (id!=2){work=i;}
	LDI  R30,LOW(2)
	CP   R30,R8
	BREQ _0x87
	MOV  R12,R9
; 0000 0149          else {work=rr;}
	RJMP _0x88
_0x87:
	LDS  R12,_rr
_0x88:
; 0000 014A          h= work/100;
	MOV  R26,R12
	LDI  R27,0
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	STS  _h,R30
; 0000 014B          work = work%100;
	MOV  R26,R12
	CLR  R27
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21
	MOV  R12,R30
; 0000 014C          t=work/10;
	MOV  R26,R12
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	STS  _t,R30
; 0000 014D          u= work%10;
	MOV  R26,R12
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	STS  _u,R30
; 0000 014E         }
_0x86:
; 0000 014F       strob();
	RCALL _strob
; 0000 0150       if(--z!=0){goto iz;}
	SUBI R17,LOW(1)
	CPI  R17,0
	BREQ _0x89
	RJMP _0x3A
; 0000 0151       };
_0x89:
	RJMP _0x2C
; 0000 0152 }
_0x8A:
	RJMP _0x8A

	.DSEG
_ar:
	.BYTE 0xA
_du:
	.BYTE 0x1
_b:
	.BYTE 0x1
_us:
	.BYTE 0x1
_un:
	.BYTE 0x1
_ut:
	.BYTE 0x1
_tt:
	.BYTE 0x1
_u:
	.BYTE 0x1
_t:
	.BYTE 0x1
_h:
	.BYTE 0x1
_rr:
	.BYTE 0x1
_zv:
	.BYTE 0x1
_e:
	.BYTE 0x1
_cap:
	.BYTE 0x2
_v:
	.BYTE 0x2

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x9C4
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

;END OF CODE MARKER
__END_OF_CODE:
